Name:           clingo
Version:        5.2.1
Release:        1%{?dist}
Summary:        A grounder and solver for logic programs

Group:          Development/Libraries
License:        MIT
URL:            http://potassco.org/clingo/
Source0:        https://github.com/potassco/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz
Patch0:         %{name}-5.2.1-unbundle_clasp.patch
Patch1:         %{name}-5.2.1-install_dir.patch
Patch2:         %{name}-5.2.1-default_shared.patch
Patch3:         %{name}-5.2.1-doc_clingo.patch

BuildRequires:  bison
BuildRequires:  clasp-devel
BuildRequires:  cmake
BuildRequires:  libpotassco-devel
BuildRequires:  re2c

%description
Clingo is part of the Potassco project for Answer Set Programming (ASP). ASP
offers a simple and powerful modeling language to describe combinatorial
problems as logic programs. The clingo system then takes such a logic program
and computes answer sets representing solutions to the given problem. To get an
idea, check our Getting Started page and the online version of clingo.

Detailed information (including a User's manual), source code, and pre-compiled
binaries are available at: http://potassco.org/

%package devel
Summary:        Development files for Clingo
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
Header and cmake modules for clingo, A grounder and solver for logic programs.

Detailed information (including a User's manual), source code, and pre-compiled
binaries are available at: http://potassco.org/

%package doc
Summary:        Documentation for Clingo
Recommends:     %{name} = %{version}-%{release}
BuildRequires:  doxygen

BuildArch:      noarch

%description doc
Generated HTML documentation for Clingo, a grounder and solver for logic
programs.

Detailed information (including a User's manual), source code, and pre-compiled
binaries are available at: http://potassco.org/

%package -n lua-%{name}
Summary:        Lua bindings for Clingo
Requires:       %{name}%{?_isa} = %{version}-%{release}
BuildRequires:  lua-devel

%description -n lua-%{name}
Lua bindings for Clingo, a grounder and solver for logic programs.

Detailed information (including a User's manual), source code, and pre-compiled
binaries are available at: http://potassco.org/

%package -n python2-%{name}
Summary:        Python bindings for Clingo
Requires:       %{name}%{?_isa} = %{version}-%{release}
BuildRequires:  python2-devel
%{?python_provide:%python_provide python2-%{name}}

%description -n python2-%{name}
This module provides functions and classes to work with ground terms and to
control the instantiation process. In clingo builts, additional functions to
control and inspect the solving process are available.
 
Functions defined in a python script block are callable during the
instantiation process using @-syntax. The default grounding/solving process can
be customized if a main function is provided.

Detailed information (including a User's manual), source code, and pre-compiled
binaries are available at: http://potassco.org/

%prep
%autosetup -p1

%build
mkdir -p build && pushd build
%cmake .. \
  -DCLINGO_BUILD_APPS:BOOL=ON \
  -DCLINGO_BUILD_LUA_SHARED:BOOL=ON \
  -DCLINGO_BUILD_PY_SHARED:BOOL=ON \
  -DCLINGO_BUILD_SHARED:BOOL=ON \
  -DCLINGO_BUILD_TESTS:BOOL=ON \
  -DCLINGO_MANAGE_RPATH:BOOL=OFF \
  -DCLINGO_REQUIRE_PYTHON:BOOL=ON \
  -DPYCLINGO_USER_INSTALL:BOOL=OFF \
  -DLUACLINGO_INSTALL_DIR:PATH=%{lua_libdir} \
  %{nil}
popd

make %{?_smp_mflags} -C build all doc_clingo

%install
%make_install -C build

%check
make %{?_smp_mflags} -C build test || true

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post -n lua-%{name} -p /sbin/ldconfig

%postun -n lua-%{name} -p /sbin/ldconfig

%post -n python2-%{name} -p /sbin/ldconfig

%postun -n python2-%{name} -p /sbin/ldconfig

%files
%doc CHANGES.md README.md
%license LICENSE.md
%{_bindir}/%{name}
%{_bindir}/gringo
%{_bindir}/reify
%{_libdir}/libclingo.so.*

%files devel
%{_includedir}/clingo*
%{_libdir}/libclingo.so
%{_libdir}/libluaclingo.so
%{_libdir}/libpyclingo.so

%files doc
%doc doc/api/html
%license LICENSE.md

%files -n lua-%{name}
%{_libdir}/libluaclingo.so.*
%{lua_libdir}/%{name}.so

%files -n python2-%{name}
%{_libdir}/libpyclingo.so.*
%{python2_sitearch}/%{name}.so

%changelog
* Sun Aug 20 2017 Scott K Logan <logans@cottsay.net> - 5.2.1-1
- Initial package
